package PPAC;

# some workers are using US phone numbers
# other area codes such as 866 877 888 etc good for discriminating spam
# from http://en.wikipedia.org/wiki/List_of_NANP_area_codes#Canada
# and from http://www.computerhope.com/areacode.htm
# hopefully between both we'll cover all possible phone numbers
our %ac = (
	403 => "Alberta",
	587 => "Alberta",
	780 => "Alberta",
	825 => "Alberta",
	236 => "British Columbia",
	250 => "British Columbia",
	604 => "British Columbia",
	672 => "British Columbia",
	778 => "British Columbia",
	204 => "Manitoba",
	431 => "Manitoba",
	506 => "New Brunswick",
	709 => "Newfoundland and Labrador",
	782 => "Nova Scotia",
	902 => "Nova Scotia",
	548 => "Ontario",
	249 => "Ontario",
	289 => "Ontario",
	343 => "Ontario",
	365 => "Ontario",
	387 => "Ontario",
	416 => "Ontario",
	437 => "Ontario",
	519 => "Ontario",
	226 => "Ontario",
	613 => "Ontario",
	647 => "Ontario",
	705 => "Ontario",
	742 => "Ontario",
	807 => "Ontario",
	905 => "Ontario",
	782 => "Prince Edward Island",
	902 => "Prince Edward Island",
	418 => "Quebec",
	438 => "Quebec",
	450 => "Quebec",
	514 => "Quebec",
	579 => "Quebec",
	581 => "Quebec",
	819 => "Quebec",
	873 => "Quebec",
	306 => "Saskatchewan",
	639 => "Saskatchewan",
	867 => "Yukon, Northwest Territories, and Nunavut",
	# from http://www.computerhope.com/areacode.htm
	# Area code	State	Location	Related	Time
	# 000		Outbound-only area code sometimes used by telemarketers and VoIP calls.		
	# 001-200  Invalid area code range  
	#  200 area codes Related Time
	201 => "NJ N New Jersey: Jersey City, Hackensack 551 UTC-5",
	202 => "DC Washington, D.C.  UTC-5",
	203 => "CT Connecticut 475, 860 UTC-5",
	204 => "MB Manitoba Canada  UTC-6",
	205 => "AL Central and Western Alabama 256, 334 UTC-6",
	206 => "WA W. Washington state: Seattle 253, 360, 425 UTC-8",
	207 => "ME Maine  UTC-5",
	208 => "ID Idaho  UTC-7 UTC-8",
	209 => "CA Central California 559, 916 UTC-8",
	210 => "TX San Antonio S. Texas 512, 830, 956 UTC-6",
	# 211 => "Unassigned area code  ",
	212 => "NY Boroughs of Manhattan in New York City 646, 718, 917 UTC-5",
	213 => "CA Los Angeles California 323 UTC-8",
	214 => "TX Dallas Texas 469, 972 UTC-6",
	215 => "PA Philadelphia Pennsylvania 267 UTC-5",
	216 => "OH Cleveland 330, 440 UTC-5",
	217 => "IL Central Illinois  UTC-6",
	218 => "MN North Minnesota  UTC-6",
	219 => "IN North Indiana  UTC-6",
	# 220-223  220, 221, 222, and 223 are unassigned area codes  
	224 => "IL Northern Northeast Illinois 224, 847 UTC-6",
	225 => "LA Louisiana 504 UTC-6",
	226 => "ON Southwest Ontario Canada 519 UTC-5",
	227 => "Future area code for Maryland  UTC-5",
	228 => "MS South Mississippi (Gulf Coast) 601 UTC-6",
	229 => "GA Southwest Georgia 912, 478 UTC-5",
	# 230 => "Unassigned area code  ",
	231 => "MI Michigan 248, 810 UTC-5",
	# 232-233  232 and 233 are unassigned area codes  
	234 => "OH Northeast Ohio 330 UTC-5",
	# 235 => "Unassigned area code  ",
	236 => "Overlay for the Canadian province of British Columbia 778 UTC-7 UTC-8",
	# 237-238  237 and 238 are unassigned area codes  
	239 => "FL Southwest Florida 305 UTC-5",
	240 => "MD Greater Washington D.C. metro and southern Maryland. 301 UTC-5",
	# 241 => "Unassigned area code  ",
	242 => "Bahamas  UTC-5",
	# 243-245  243, 244, and 245 are unassigned area codes  
	246 => "Barbados  UTC-4",
	# 247 => "Unassigned area code  ",
	248 => "MI Michigan: Oakland county 231, 810, 947 UTC-5",
	249 => "ON Ontario Canada  UTC-5",
	250 => "BC British Columbia 604 UTC-7 UTC-8",
	251 => "AL Southwestern Alabama 205, 256, 334 UTC-6",
	252 => "NC Northeastern North Carolina 919 UTC-5",
	253 => "WA South Washington 206, 425, 564 UTC-8",
	254 => "TX Central Texas in the Waco area 817, 940 UTC-6",
	# 255 => "Unassigned area code  ",
	256 => "AL Northeast Alabama in the Huntsville, Decatur area 205, 334, 938 UTC-6",
	# 257-259  257, 258, and 259 are unassigned area codes  
	260 => "IN Northeast Indiana 219 UTC-5",
	# 261 => "Unassigned area code  ",
	262 => "WI Southeastern Wisconsin, surrounding Milwaukee 414, 920 UTC-6",
	# # 263 => "Unassigned area code  ",
	264 => "Anguilla 809 UTC-4",
	# 265-266  265 and 266 are unassigned area codes  
	267 => "PA Southeast Pennsylvania: Philadelphia 215 UTC-5",
	268 => "Antigua and Barbuda 809 UTC-4",
	269 => "MI Southwest Michigan 616 UTC-5",
	270 => "KY West Kentucky 364, 502 UTC-5 UTC-6",
	# # 271 => "Unassigned area code  ",
	272 => "Future area code for Pennsylvania  UTC-5",
	# 273 => "Unassigned area code  ",
	274 => "Future area code for Wisconsin  UTC-6",
	# 275 => "Unassigned area code  ",
	276 => "VA South Virginia 540 UTC-5",
	# 277-280  277, 278, 279, and 280 are unassigned area codes  
	281 => "TX Texas: Houston Metro 713, 832 UTC-6",
	# 282 => "Unassigned area codes  ",
	283 => "Future area code for Ohio  UTC-5",
	284 => "British Virgin Islands 809 UTC-4",
	# 285-288  285, 286, 287, and 288 are unassigned area codes  
	289 => "ON South Central Canada 905 UTC-5",
	# 290-300  290, 291, 292, 293, 294, 295, 296, 297, 298, 299, and 300 are unassigned area codes  
	#  300 area codes Related Time
	301 => "MD W Maryland: Silver Spring, Frederick 240 UTC-5",
	302 => "DE Delaware  UTC-5",
	303 => "CO Central Colorado: Denver, Boulder, Longmont, Aurora 720 UTC-7",
	304 => "WV West Virginia 681 UTC-5",
	305 => "FL Southeast Florida: Miami 239, 786, 954 UTC-5",
	306 => "SK Saskatchewan Canada  UTC-6",
	307 => "WY Wyoming  UTC-7",
	308 => "NE West Nebraska  UTC-6 UTC-7",
	309 => "IL West Central Illinois  UTC-6",
	310 => "CA South California: West Los Angeles and South Bay 424, 562 UTC-8",
	311 => "Reserved for Municipal Assistance.  ",
	312 => "IL Chicago, Illinois (Downtown only) 773, 872 UTC-6",
	313 => "MI Detroit Michigan and suburbs 248, 586, 734, 810 UTC-5",
	314 => "MO Missouri: Independent city of St Louis and neighboring counties 618, 636 UTC-6",
	315 => "NY North Central upstate New York  UTC-5",
	316 => "KS Wichita, Kansas 620 UTC-6",
	317 => "IN Central Indiana 765 UTC-5",
	318 => "LA Northern Louisiana 337, 504 UTC-6",
	319 => "IA East-central and southeast Iowa  UTC-6",
	320 => "MN Central Minnesota  UTC-6",
	321 => "FL Florida: Brevard County 407 UTC-5",
	# 322 => "Unassigned area code  ",
	323 => "CA Central Los Angeles California, excluding downtown Los Angeles 213 UTC-8",
	# 324 => "Unassigned area code  ",
	325 => "TX Central Texas in the Abilene and San Angelo areas 915 UTC-6",
	# 326 => "Unassigned area code  ",
	327 => "Future area code for Arkansas  UTC-6",
	# 328-329  328 and 329 are unassigned area codes  
	330 => "OH Northeast Ohio: Akron, Canton, and Youngstown area 216, 234, 440 UTC-5",
	331 => "IL Northeast Illinois, covering parts of Chicago's western suburbs 630, 708 UTC-6",
	# 332-333  332 and 333 are unassigned area codes  
	334 => "AL South Alabama 251 UTC-6",
	# 335 => "Unassigned area code  ",
	336 => "NC Central North Carolina, mainly Piedmont Triad region 910 UTC-5",
	337 => "LA Southwestern Louisiana 318 UTC-6",
	# 338 => "Unassigned area code  ",
	339 => "MA Massachusetts: Boston and most of the South Shore 781 UTC-5",
	340 => "US Virgin Islands 809 UTC-4",
	# 341-342  341 and 342 are unassigned area codes  
	343 => "Ontario, Canada  UTC-5",
	# 344 => "Unassigned area code  ",
	345 => "Cayman Islands  UTC-5",
	# 346 => "Unassigned area code  ",
	347 => "NY New York: Brooklyn, Queens, the Bronx, Staten Island, sections of Manhattan 718, 917 UTC-5",
	# 348-350  348, 349, 350 are unassigned area codes  
	351 => "MA North Massachusetts 508, 781, 978 UTC-5",
	352 => "FL Florida 904 UTC-5",
	# 353-359  353, 354, 355, 356, 357, 358, and 359 are unassigned area codes  
	360 => "WA Western Washington State outside Seattle 206 UTC-8",
	361 => "TX Texas: in the Corpus Christi area 512 UTC-6",
	# 362-363  362 and 363 are unassigned area codes  
	364 => "Purposed area code for Kentucky  UTC-6",
	365 => "Future area code for Ontario  UTC-5",
	# 366-368  366, 367, and 368 are unassigned area codes  
	369 => "Future area code for California  UTC-8",
	# 370-379  370, 371, 372, 373, 374, 375, 376, 377, 378, and 379 are unassigned area codes  
	380 => "Future area code for Ohio  UTC-5",
	# 381-384  381, 382, 383,and 384 are unassigned area codes  
	385 => "UT Utah 435, 801 UTC-7",
	386 => "FL Florida: Columbia, Flagler, Hamilton, Lafayette, and Daytona Beach 904 UTC-5",
	# 387-400  387, 388, 389, 390, 391, 392, 393, 394, 395, 396, 397, 398, 399, and 400 are unassigned area codes  
	#  400 area codes Related Time
	401 => "RI Rhode Island  UTC-5",
	402 => "NE East Nebraska 531 UTC-6",
	403 => "AB Alberta 780, 867 UTC-7",
	404 => "GA Georgia: Atlanta and its immediate neighbors 229, 470, 912 UTC-5",
	405 => "OK Oklahoma City metro 580, 918 UTC-6",
	406 => "MT Montana  UTC-7",
	407 => "FL Florida: Orlando metro including Orange, Osceola, and Seminole  UTC-5",
	408 => "CA California: Cupertino, Los Gatos, Milpitas, Sunnyvale, Santa Clara, and San Jose area. 415 UTC-8",
	409 => "TX Southeast Texas: Beaumont and Galveston areas 936 UTC-6",
	410 => "MD East Maryland 443 UTC-5",
	411 => "Not an area code - information 511, 911 ",
	412 => "PA West Pennsylvania: Most Allegheny including Pittsburgh 724, 878 UTC-5",
	413 => "MA Western Massachusetts  UTC-5",
	414 => "WI Southeast Wisconsin: Milwaukee 262, 920 UTC-6",
	415 => "CA California: San Francisco and northern suburbs 408, 650 UTC-8",
	416 => "ON Canada: Metropolitan Toronto 647 UTC-5",
	417 => "MO Southwestern Missouri: Branson, Carl Junction, Carthage, Joplin, and Springfield  UTC-6",
	418 => "QC Northeast Quebec  UTC-5",
	419 => "OH Northwest and north central Ohio: Toledo 567 UTC-5",
	# 420-422  420, 421, and 422 are unassigned area codes  
	423 => "TN East Tennessee 615, 865 UTC-5",
	424 => "CA Los Angeles, South California 310, 562 UTC-8",
	425 => "WA North Washington and east of Seattle 206, 253, 564 UTC-8",
	# 426-429  426, 427, 428, and 429 are unassigned area codes  
	430 => "TX Northeast Texas including Texarkana, Tyler, and Sherman 903 UTC-6",
	431 => "Future area code for Manitoba  UTC-6",
	432 => "TX West Texas in the Permian Basin area 915 UTC-6",
	# 433 => "Unassigned area code  ",
	434 => "VA East Virginia 804 UTC-5",
	435 => "UT Utah outside Salt Lake City, Ogden, and Provo 801 UTC-7",
	# 436 => "Unassigned area code  ",
	437 => "Future area code for Ontario  UTC-5",
	438 => "QC Canada: Southwest Quebec 514 UTC-5",
	# 439 => "Unassigned area code  ",
	440 => "OH Ohio: Cleveland metro area, excluding Cleveland 216, 330 UTC-5",
	441 => "Bermuda 809 UTC-4",
	442 => "CA Southeastern California 760 UTC-8",
	443 => "MD East Maryland 410 UTC-5",
	# 444-446  444, 445, and 446 are unassigned area codes  
	447 => "Future area code for Illinois  UTC-6",
	# 448-449  448 and 449 areunassigned area codes  
	450 => "QC Southeastern Quebec outside metro Montreal  UTC-5",
	# 451-455  451, 452, 453, 454, and 455 are unassigned area codes  
	456 => "International Inbound  ",
	# 457 => "Unassigned area codes  ",
	458 => "OR Oregon: All but northeast corner 541 UTC-8",
	# 459-463  459, 460, 461, 462, and 463 are unassigned area codes  
	464 => "IL Future area code for Illinois  UTC-6",
	# 465-468  465, 466, 467, and 468 are unassigned area codes  
	469 => "TX Texas 214, 972 UTC-6",
	470 => "GA Georgia 404, 678, 770 UTC-5",
	# 471-472  471 and 472 are unassigned area codes  
	473 => "Grenada 809 UTC-4",
	# 474 => "Unassigned area codes  ",
	475 => "CT Connecticut  UTC-5",
	# 476-477  476 and 477 are unassigned area codes  
	478 => "GA Georgia: covering Macon and Middle Georgia 229, 912 UTC-5",
	479 => "AR Northwest Arkansas 501 UTC-6",
	480 => "AZ Arizona 602, 623 UTC-7",
	# 481-483  481, 482, and 483 are unassigned area codes  
	484 => "PA Southeast Pennsylvania: Allentown, Bethlehem, and Reading 610, 835 UTC-5",
	# 485-499  are unassigned area codes  
	#  500 area codes Related Time
	# 500 => "Personal Communications Services 533, 544 ",
	501 => "AR Central Arkansas including Little Rock 870 UTC-6",
	502 => "KY West Kentucky: Louisville and Frankfort 270 UTC-5",
	503 => "OR Oregon: Portland, Salem, McMinnville, Tillamook, and other northwestern locations 971 UTC-8",
	504 => "LA Louisiana: greater New Orleans 225, 985, 318 UTC-6",
	505 => "NM New Mexico 575 UTC-7",
	506 => "NB New Brunswick Canada  UTC-4",
	507 => "MN South Minnesota: Rochester, Mankato, Worthington, Fairmont, and Austin  UTC-6",
	508 => "MA Southcentral Massachusetts: Framingham 774 UTC-5",
	509 => "WA East Washington: Spokane, the Tri-Cities, Yakima, Walla Walla, and Wanatchee  UTC-8",
	510 => "CA California: Oakland, East Bay 925 UTC-8",
	511 => "Travel information line.  ",
	512 => "TX Texas: In and near Austin  UTC-6",
	513 => "OH Southwest Ohio 937 UTC-5",
	514 => "QC Southwest Quebec: Montreal 438 UTC-5",
	515 => "IA Central Iowa: Ames, Ankeny, Des Moines, Boone, Fort Dodge, and Indianola 641 UTC-6",
	516 => "NY New York: Nassau county on Long Island and Hempstead 631 UTC-5",
	517 => "MI Central Michigan 989 UTC-5",
	518 => "NY Northeast New York: Mohawk Valley to East of Albany  UTC-5",
	519 => "ON Southwest Ontario: Windsor 226 UTC-5",
	520 => "AZ Arizona outside the Phoenix area 602, 928 UTC-7",
	# 521-529  521, 522, 523, 524, 525, 526, 527, 528, and 529 are unassigned area codes  
	530 => "CA Northeast California: Auburn, Chico, Colfax, Davis, Redding, Yuba City, and Red Bluff 916 UTC-8",
	531 => "NE East Nebraska 402 UTC-6",
	# 532 => "Unassigned area code  ",
	533 => "Personal Communications Services 500, 544 ",
	534 => "WI North Wisconsin 715 UTC-6",
	# 535-538  535, 536, 537, and 538 are unassigned area codes  
	539 => "OK Oklahoma 918 UTC-6",
	540 => "VA Northwest Virginia: Fredericksburg and Roanoke and nearby areas 571, 703 UTC-5",
	541 => "OR All of Oregon except northwest portion 458 UTC-8",
	# 542-543  542 and 543 are unassigned area codes  
	544 => "Personal Communications Services 500, 533 ",
	# 545-550  545, 546, 547, 548, 549, and 550 are unassigned area codes  
	551 => "NJ North New Jersey 201 UTC-5",
	# 552-556  552, 553, 554, 555, and 556 are unassigned area codes  
	557 => "Future area code for Missouri  UTC-6",
	# 558 => "Unassigned area codes  ",
	559 => "CA Central California: Fresno, Kings, and Tulare 209 UTC-8",
	# 560 => "Unassigned area codes  ",
	561 => "FL Florida: Palm Beach County 407 UTC-5",
	562 => "CA Southeastern California: Los Angeles County and Northern Orange County 310 UTC-8",
	563 => "IA East Iowa 319 UTC-6",
	564 => "Future area code for Washington  UTC-8",
	# 565-566  565 and 566 are unassigned area codes  
	567 => "OH Northwest Ohio 419 UTC-5",
	# 568-569  568 and 569 are Unassigned area codes  
	570 => "PA Northeast Pennsylvania: Williamsport, Wilkes-Barre, Scranton, and Sayre 717 UTC-5",
	571 => "VA North Virginia 540, 703 UTC-5",
	# 572 => "Unassigned area code  ",
	573 => "MO Missouri: excluding St Louis metro area  UTC-6",
	574 => "IN North Indiana 219 UTC-5",
	575 => "NM New Mexico, outside of the Albuquerque, Santa Fe, Farmington, and Gallup areas 505 UTC-7",
	# 576-578  576, 577, and 578 are unassigned area codes  
	579 => "QC Quebec, Canada  UTC-5",
	580 => "OK Western and Southern Oklahoma 405 UTC-6",
	581 => "QC Quebec, Canada  UTC-5",
	582 => "Future area code for Pennsylvania  UTC-5",
	# 583-584  583 and 584 are Unassigned area codes  
	585 => "NY Northwest New York: Rochester 716 UTC-5",
	586 => "MI Michigan: Macomb County in the Metro Detroit area 810 UTC-5",
	587 => "Alberta, Canada  UTC-7",
	# 588-599  588, 589, 590, 591, 592, 593, 594, 595, 596, 597, 598, and 599 are unassigned area codes  
	#  600 area codes Related Time
	# 600 => "Canadian Services  ",
	601 => "MS Central Mississippi 769 UTC-6",
	602 => "AZ Arizona: Most of Phoenix 480, 623 UTC-7",
	603 => "NH New Hampshire  UTC-5",
	604 => "BC Canada: British Columbia, Greater Vancouver 250, 778 UTC-8",
	605 => "SD South Dakota  UTC-6 UTC-7",
	606 => "KY East Kentucky 859 UTC-5",
	607 => "NY New York South Central: Ithaca, Binghamton  UTC-5",
	608 => "WI Southwest Wisconsin: Madison  UTC-6",
	609 => "NJ South New Jersey: Trenton and Atlantic City 856 UTC-5",
	610 => "PA Southeast Pennsylvania: Allentown, Reading 484, 835 UTC-5",
	# # 611 => "Unassigned area codes  ",
	612 => "MN Central Minnesota, Minneapolis, and some surrounding areas 651, 763, 952 UTC-6",
	613 => "ON Canada: Southeast Ontario, Ottawa  UTC-5",
	614 => "OH Southeast Ohio: Columbus 380, 740 UTC-5",
	615 => "TN East Tennessee: Nashville 423, 931 UTC-6",
	616 => "MI West Michigan: Grand Rapids 269 UTC-5",
	617 => "MA East Massachusetts: Boston 857 UTC-5",
	618 => "IL South Illinois  UTC-6",
	619 => "CA South California: Southern half of San Diego 760, 858, 935 UTC-8",
	620 => "KS South Kansas excluding Wichita Metropolitan Area 316 UTC-6",
	# 621-622  621 and 622 are unassigned area codes  
	623 => "AZ Arizona 480, 520, 602 UTC-7",
	# 624-625  624 and 625 are Unassigned area codes  
	626 => "CA Southeast California: 818 UTC-8",
	627 => "Future area code for California  UTC-8",
	628 => "Future area code for California  UTC-8",
	# 629 => "Unassigned area code  ",
	630 => "IL Northeast Illinois, Oak Brook or Chicago suburbs 312, 331, 708 UTC-6",
	631 => "NY New York: Suffolk County 516 UTC-5",
	# 632-635  632, 633, 634, and 635 are unassigned area codes  
	636 => "MO East-central Missouri 314, 573 UTC-6",
	# 637-638  637 and 638 are unassigned area codes  
	639 => "Future area code for Saskatchewan  UTC-6",
	# 640 => "Unassigned area code  ",
	641 => "IA Central Iowa: Mason City and Ottumwa 515 UTC-6",
	# 642-645  642, 643, and 644 are unassigned area codes  
	646 => "NY Manhattan New York 212, 917 UTC-5",
	647 => "ON South Central Ontario 416 UTC-5",
	# 648 => "Unassigned area code  ",
	649 => "Turks and Caicos Islands  UTC-5",
	650 => "CA Peninsula south of San Francisco -- San Mateo county, parts of Santa Clara county 415 UTC-8",
	651 => "MN East-Central Minnesota, St. Paul 612, 763, 952 UTC-6",
	# 652-656  652, 653, 654, 655, and 656 are unassigned area codes  
	657 => "CA Orange County, California 714 UTC-6",
	# 658 => "Unassigned area code  ",
	659 => "Future area code for Alabama  UTC-6",
	660 => "MO Northern and Western Missouri 816 UTC-6",
	661 => "CA California: 805 UTC-8",
	662 => "MS Mississippi 601 UTC-6",
	# 663 => "Unassigned area code  ",
	664 => "Montserrat 809 UTC-4",
	# 665-666  665 and 666 are unassigned area codes  
	667 => "Future area code for Maryland  UTC-5",
	# 668 => "Unassigned area code  ",
	669 => "Future area code for California  UTC-6",
	670 => "Commonwealth of the Northern Mariana Islands  UTC+10",
	671 => "Guam  UTC+10",
	# 672-677  672, 673, 674, 675, 676, and 677 are unassigned area codes  
	678 => "GA North Georgia: Atlanta 404, 470, 770 UTC-5",
	679 => "Future area code for Michigan  UTC-5",
	# 680 => "Unassigned area code  ",
	681 => "WV West Virginia 304 UTC-5",
	682 => "TX Fort Worth Texas 817 UTC-6",
	# 683 => "Unassigned area code  ",
	684 => "American Samoa  UTC-11",
	# 685-688  685, 686, 687, and 688 are unassigned area codes  
	689 => "Future area code for Florida  UTC-5",
	# 690-699  690, 691, 692, 693, 694, 695, 696, 697, 698, and 699 are unassigned area codes  
	#  700 area codes Related Time
	700 => "Interconnect Services  ",
	701 => "ND North Dakota  UTC-6 UTC-7",
	702 => "NV South Nevada: Las Vegas 775 UTC-8",
	703 => "VA Northern Virginia: Arlington, McLean, Tysons Corner 540, 571 UTC-5",
	704 => "NC West North Carolina: Charlotte  UTC-5",
	705 => "ON Canada: Northwest Ontario, Sault Ste. Marie  UTC-5",
	706 => "GA North and Northeast Georgia: Columbus, Augusta 762 UTC-5",
	707 => "CA Northwest California: Santa Rosa  UTC-8",
	708 => "IL Illinois: western and southern Cook County 464, 630, 847 UTC-6",
	709 => "NF Canada Newfoundland  UTC-3:30",
	710 => "US Government  ",
	# 711 => "Unassigned area code  ",
	712 => "IA West Iowa  UTC-6",
	713 => "TX Mid Southeast Texas: Houston 281, 832 UTC-6",
	714 => "CA North Orange County, California 657, 949 UTC-8",
	715 => "WI North Wisconsin 534 UTC-6",
	716 => "NY Western New York: Buffalo, Rochester 585 UTC-5",
	717 => "PA South central Pennsylvania: Wilkes-Barre, Scranton  UTC-5",
	718 => "NY New York City, New York, the Bronx, Queens, Brooklyn, and Staten Island 212, 347 UTC-5",
	719 => "CO Southeast Colorado: Pueblo, Colorado Springs  UTC-7",
	720 => "CO Central Colorado: Denver 303 UTC-7",
	721 => "Former Netherlands Antilles  UTC-4",
	# 722-723  722 and 723 are unassigned area codes  
	724 => "PA Southwest Pennsylvania 412, 878 UTC-5",
	# 725-726  725 and 726 are unassigned area codes  
	727 => "FL Florida: Tampa Metro, Saint Petersburg, and Clearwater 813 UTC-5",
	# 728-729  728 and 729 are unassigned area codes  
	730 => "Future area code for Illinois  UTC-6",
	731 => "TN West Tennessee 901 UTC-6",
	732 => "NJ Central New Jersey: New Brunswick, Bound Brook 848, 908 UTC-5",
	# 733 => "Unassigned area code  ",
	734 => "MI Southeast Michigan: west and south of Detroit -- Ann Arbor, Monroe 313 UTC-5",
	# 735-736  735 and 736 areUnassigned area codes  
	737 => "Future area code for Texas  UTC-6",
	# 738-739  738 and 739 are unassigned area codes  
	740 => "OH Southeast Ohio 614, 380 UTC-5",
	# 741-746  741, 742, 743, 744, 745, and 746 are unassigned area codes  
	747 => "CA California: San Fernando Valley of Los Angeles 818 UTC-8",
	# 748-753  748, 749, 750, 751, 752, and 753 are unassigned area codes  
	754 => "FL Florida: Broward County 954 UTC-5",
	# 755-756  755 and 756 are unassigned area codes  
	757 => "VA Southeast Virginia, Williamsburgh area, including Portsmouth 804 UTC-5",
	758 => "St. Lucia 809 UTC-4",
	# 759 => "Unassigned area code  ",
	760 => "CA California: Southeastern San Diego north to Sierra Nevada 442, 619 UTC-8",
	# 761 => "Unassigned area code  ",
	762 => "GA North and Northeast Georgia: Columbus, Augusta 706 UTC-5",
	763 => "MN Minnesota 612, 952, 651 UTC-6",
	764 => "Future area code for California  UTC-8",
	765 => "IN Indiana: outside Indianapolis 317 UTC-5",
	# 766 => "Unassigned area code  ",
	767 => "Dominica  UTC-4",
	# 768 => "Unassigned area code  ",
	769 => "MS Central Mississippi 601 UTC-6",
	770 => "GA Georgia: Atlanta and suburbs 285, 404, 678 UTC-5",
	# 771 => "Unassigned area code  ",
	772 => "FL South central Florida: Treasure Coast 561 UTC-5",
	773 => "IL Illinois: Non-downtown Chicago 312, 872 UTC-6",
	774 => "MA Massachusetts 508, 978 UTC-5",
	775 => "NV Nevada 702 UTC-8",
	# 776-777  776 and 777 are Unassigned area codes  
	778 => "BC British Colombia Canada 236, 250, 604 UTC-7 UTC-8",
	779 => "IL North Illinois: around Moline 815 UTC-6",
	780 => "AB Alberta Canada 403 UTC-7",
	781 => "MA East Massachusetts: Boston suburbs 339, 508, 617 UTC-5",
	# 782-783  782 and 783 are Unassigned area codes  
	784 => "St. Vincent/Grenadines 809 UTC-4",
	785 => "KS North Kansas: Topeka 913 UTC-6",
	786 => "FL Southeast Florida 305 UTC-5",
	787 => "PR Puerto Rico 939 UTC-4",
	# 788-799  788, 789, 790, 791, 792, 793, 794, 795, 796, 797, 798, and 799 are unassigned area codes  
	#  800 area codes Related Time
	800 => "Domestic Toll-Free 888, 877, 866, 855, 844, 833, 822 ",
	801 => "UT Salt Lake City Metro 385, 435 UTC-7",
	802 => "VT Vermont  UTC-5",
	803 => "SC South Carolina 843, 864 UTC-5",
	804 => "VA East Virginia: Richmond 434, 757 UTC-5",
	805 => "CA South Central Coastal California: 661 UTC-8",
	806 => "TX North Texas: Amarillo and Lubbock  UTC-6",
	807 => "ON Canada: West Ontario, Thunder Bay  UTC-5 UTC-6",
	808 => "HI HAWAII  UTC-10",
	809 => "Bermuda, Puerto Rico, Virgin Islands, Caribbean 441,340 UTC-4",
	810 => "MI East Michigan: Flint, Pontiac 248, 586 UTC-5",
	# 811 => "Unassigned area codes  ",
	812 => "IN South Indiana: Evansville  UTC-5",
	813 => "FL Southwest Florida: Tampa Metro 727, 941 UTC-5",
	814 => "PA Central Pennsylvania: Altoona, Bradford, and Erie  UTC-5",
	815 => "IL Northeast Illinois: Rockford, Kankakee  UTC-6",
	816 => "MO Missouri: Kansas City area 660, 975 UTC-6",
	817 => "TX North-Central Texas: Fort Worth area 682 UTC-6",
	818 => "CA South California: San Fernando and Los Angeles 747 UTC-8",
	819 => "QC Canada: Northwest Quebec: Trois Rivieres 867 UTC-5",
	# 820-821  820 and 821 are unassigned area codes  
	822 => "US/Canada Toll-Free  ",
	# 823-827  823, 824, 825, 826, and 827 are unassigned area codes  
	828 => "NC West North Carolina: Asheville 704 UTC-5",
	829 => "Dominican Republic  UTC-4",
	830 => "TX Texas: North and West of San Antonio 210 UTC-6",
	831 => "CA West-Central California: Santa Cruz through Monterey County  UTC-8",
	832 => "TX Texas: Houston 281, 713, 936 UTC-6",
	833 => "US/Canada Toll-Free  ",
	# 834 => "Unassigned area codes  ",
	835 => "PA Southeast Pennsylvania 484, 610 UTC-5",
	# 836-842  836, 837, 838, 839, 840, 841, and 842 are unassigned area codes  
	843 => "SC East South Carolina: Myrtle Beach, Charleston 803 UTC-5",
	844 => "US/Canada Toll-Free  ",
	845 => "NY New York: Rockland, Putnam, Orange, Dutchess Ulster 914 UTC-5",
	# 846 => "Unassigned area code  ",
	847 => "IL Northern Northeast Illinois: Oak Brook 224, 312 UTC-6",
	848 => "NJ Central New Jersey 732 UTC-5",
	849 => "Dominican Republic  UTC-4",
	850 => "FL Florida panhandle, from east of Tallahassee to Pensacola 904 UTC-5 UTC-6",
	# 851-854  851, 852, 853, and 854 are unassigned area codes  
	855 => "US/Canada Toll-Free  ",
	856 => "NJ Southwest New Jersey 609 UTC-5",
	857 => "MA Massachusetts 617 UTC-5",
	858 => "CA South west California: San Diego 619, 760, 935 UTC-8",
	859 => "KY Kentucky 606 UTC-5",
	860 => "CT Connecticut 203, 959 UTC-5",
	# 861 => "Unassigned area code  ",
	862 => "NJ North New Jersey 973 UTC-5",
	863 => "FL South-central Florida: Lakeland, Bartow, Winter Haven, Lake Wales  UTC-5",
	864 => "SC South Carolina 803 UTC-5",
	865 => "TN Tennessee: Knox County 423, 615 UTC-5",
	866 => "US/Canada Toll-Free  ",
	867 => "YT Canada: Yukon and Northwest Territories 403, 819 UTC-6 UTC-7 UTC-8",
	868 => "Trinidad and Tobago  UTC-4",
	869 => "Sant Kitts and Nevis  UTC-4",
	870 => "AR South Arkansas 501 UTC-6",
	# 871 => "Unassigned area code  ",
	872 => "IL Illinois: Chicago 312, 773 UTC-6",
	873 => "Future area code for Quebec  UTC-4 UTC-5",
	# 874-875  874 and 875 are unassigned area codes  
	876 => "Jamaica  UTC-5",
	877 => "Domestic Toll-Free  ",
	878 => "PA Pittsburgh: Pittsburgh 412, 724 UTC-5",
	# 879-887  879, 880, 881, 882, 883, 884, 885, 886, and 887 are unassigned area codes  
	888 => "Domestic Toll-Free  ",
	# 889-897  889, 890, 891, 892, 893, 894, 895, 896, and 897 are unassigned area codes  
	898 => "VoIP service  ",
	# 899 => "Unassigned area code  ",
	#  900 area codes Related Time
	900 => "Personal paid service line  ",
	901 => "TN West Tennessee: Memphis 615, 731, 931 UTC-6",
	902 => "NS Canada: Nova Scotia, Prince Edward Island  UTC-4",
	903 => "TX Northeast Texas: Tyler 430 UTC-6",
	904 => "FL North Florida: Jacksonville 352, 386, 850 UTC-5",
	905 => "ON South central Ontario, Canada 416, 647 UTC-5",
	906 => "MI Upper Peninsula Michigan: Sault Ste. Marie, Escanaba, Marquette  UTC-5",
	907 => "AK Alaska  UTC-9",
	908 => "NJ Central New Jersey: Elizabeth, Basking Ridge, Somerville, Bridgewater 732 UTC-5",
	909 => "CA California: Corona Riverside and Moreno Valley 951 UTC-8",
	910 => "NC South Central North Carolina: Fayetteville, Wilmington 336 UTC-5",
	911 => "Emergency Help 411 ",
	912 => "GA South Georgia: Savannah 229, 478 UTC-5",
	913 => "KS North East Kansas/Kansas City Metro/Leavenworth 785 UTC-6",
	914 => "NY New York: Westchester County 845 UTC-5",
	915 => "TX West Texas: El Paso area 432 UTC-6",
	916 => "CA Northeast California: Sacramento 530 UTC-8",
	917 => "NY New York City, New York 646, 929 UTC-5",
	918 => "OK East Oklahoma: Tulsa 405, 539, 580 UTC-6",
	919 => "NC East North Carolina: Raleigh 252, 984 UTC-5",
	920 => "WI Northeast Wisconsin 274, 414 UTC-6",
	# 921-924  921, 922, 922, and 924 are unassigned area codes  
	925 => "CA California: East Bay 510 UTC-8",
	# 926-927  926 and 927 are unassigned area codes  
	928 => "AZ Arizona: Grand Canyon, Flagstaff, Lake Havasu City, Kingman 520 UTC-7",
	929 => "NY New York: Brooklyn, Queens, the Bronx, and Staten Island 718, 347, 917 UTC-5",
	# 930 => "Unassigned area code  ",
	931 => "TN Central Tennessee 615 UTC-6",
	# 932-934  932, 933, and 934 are unassigned area codes  
	935 => "Future area code for California  UTC-8",
	936 => "TX Southeast Texas: Huntsville 409 UTC-6",
	937 => "OH Southwest Ohio: Dayton 513 UTC-5",
	938 => "AL Alabama 256 UTC-6",
	939 => "PR Puerto Rico 787 UTC-4",
	940 => "TX North Central Texas: Denton, Wichita Falls 254, 817, 936 UTC-6",
	941 => "FL Southwest Florida: Tampa Area 813, 863 UTC-5",
	# 942-946  942, 943, 944, 945, and 946 are unassigned area codes  
	947 => "MI Michigan 248 UTC-5",
	# 948 => "Unassigned area code  ",
	949 => "CA California: South Coastal Orange County 714 UTC-8",
	# 950 => "Unassigned area code  ",
	951 => "CA California: West Riverside County 909 UTC-8",
	952 => "MN Minnesota: Southwestern suburbs of Minneapolis-St. Paul 612, 763, 651 UTC-6",
	# 953 => "Unassigned area code  ",
	954 => "FL Broward County area, including Ft. Lauderdale 305, 754 UTC-5",
	# 955 => "Unassigned area code  ",
	956 => "TX South Texas: Brownsville, McAllen, Laredo, and South Padre Island 210 UTC-6",
	# 957-958  957 and 958 are unassigned area codes  
	959 => "CT Connecticut 860 UTC-5",
	# 960-969  960, 961, 962, 963, 964, 965, 966, 967, 968, 969 are unassigned area codes  
	970 => "CO North and West Colorado: Aspen, Vail, Durango, Grand Junction 303 UTC-7",
	971 => "OR Oregon: Portland, Salem, McMinnville, Tillamook, and other northwestern locations 503 UTC-8",
	972 => "TX Texas: Dallas Metro: Dallas and parts of Denton and Collin counties 214, 469 UTC-6",
	973 => "NJ North New Jersey: Newark Paterson Morristown 201, 862 UTC-5",
	# 974 => "Unassigned area code  ",
	975 => "Future area code for Missouri  UTC-6",
	# 976-977  976 and 977 are unassigned area codes  
	978 => "MA Central Massachusetts 351 UTC-5",
	979 => "TX Southeast Texas 409, 936 UTC-6",
	980 => "NC North Carolina 704 UTC-5",
	# 981-983  981, 982, and 983 are unassigned area codes  
	984 => "Future area code for North Carolina  UTC-5",
	985 => "LA Southeastern Louisiana: excludes New Orleans 504 UTC-6",
	# 986-988  986, 987, and 988 are Unassigned area codes  
	989 => "MI Michigan: Alma, Alpena, Bad Axe, Bay City, Caro, Clare, Midland 517 UTC-5",
	# 990-999  990, 991, 992, 993, 994, 995, 996, 997, 998, 999 are unassigned area codes  

);
our @keys = reverse sort keys %ac;
our $acpat = join "|", @keys;
$acpat = qr/$acpat/;

our %canada = (
          '403' => 'AB', # Alberta 780, 867 UTC-7',
          '587' => 'AB', # Alberta, Canada  UTC-7',
          '780' => 'AB', # Alberta Canada 403 UTC-7',
          '825' => 'AB', # Alberta',

          '236' => 'BC', # Overlay for the Canadian province of British Columbia 778 UTC-7 UTC-8',
          '250' => 'BC', # British Columbia 604 UTC-7 UTC-8',
          '604' => 'BC', # Canada: British Columbia, Greater Vancouver 250, 778 UTC-8',
          '672' => 'BC', # British Columbia',
          '778' => 'BC', # British Colombia Canada 236, 250, 604 UTC-7 UTC-8',

          '204' => 'MB', # Manitoba Canada  UTC-6',

          '506' => 'NB', # New Brunswick Canada  UTC-4',
          '709' => 'NF', # Canada Newfoundland  UTC-3:30',
          '902' => 'NS', # Canada: Nova Scotia, Prince Edward Island  UTC-4',

          '226' => 'ON', # Southwest Ontario Canada 519 UTC-5',
          '249' => 'ON', # Ontario Canada  UTC-5',
          '343' => 'ON', # Ontario, Canada  UTC-5',
          '416' => 'ON', # Canada: Metropolitan Toronto 647 UTC-5',
          '519' => 'ON', # Southwest Ontario: Windsor 226 UTC-5',
          '548' => 'ON', # Ontario',
          '647' => 'ON', # South Central Ontario 416 UTC-5',
          '705' => 'ON', # Canada: Northwest Ontario, Sault Ste. Marie  UTC-5',
          '807' => 'ON', # Canada: West Ontario, Thunder Bay  UTC-5 UTC-6',
          '742' => 'ON', # Ontario',
          '387' => 'ON', # Ontario',
          '613' => 'ON', # Canada: Southeast Ontario, Ottawa  UTC-5',
          '905' => 'ON', # South central Ontario, Canada 416, 647 UTC-5',
          '289' => 'ON', # South Central Canada 905 UTC-5',

          '782' => 'PE', # Prince Edward Island',

          '418' => 'QC', # Northeast Quebec  UTC-5',
          '450' => 'QC', # Southeastern Quebec outside metro Montreal  UTC-5',
          '438' => 'QC', # Canada: Southwest Quebec 514 UTC-5',
          '514' => 'QC', # Southwest Quebec: Montreal 438 UTC-5',
          '579' => 'QC', # Quebec, Canada  UTC-5',
          '581' => 'QC', # Quebec, Canada  UTC-5',
          '819' => 'QC', # Canada: Northwest Quebec: Trois Rivieres 867 UTC-5',

          '306' => 'SK', # Saskatchewan Canada  UTC-6',

          '867' => 'YT', # Canada: Yukon and Northwest Territories 403, 819 UTC-6 UTC-7 UTC-8',

          # '437' => 'Future area code for Ontario  UTC-5',
          # '855' => 'US/Canada Toll-Free  ',
          # '873' => 'Future area code for Quebec  UTC-4 UTC-5',
          # '639' => 'Future area code for Saskatchewan  UTC-6',
          # '365' => 'Future area code for Ontario  UTC-5',
          # '822' => 'US/Canada Toll-Free  ',
          # '844' => 'US/Canada Toll-Free  ',
          # '431' => 'Future area code for Manitoba  UTC-6',
          # '833' => 'US/Canada Toll-Free  ',
          # '866' => 'US/Canada Toll-Free  ',
);

# list of location identifying url parts
our %locales = (
	'site2' => {
		'alberta.site2.com' => 'AB',
		'britishcolumbia.site2.com' => 'BC',
		'halifax.site2.com' => 'NS',
		'newbrunswick.site2.com' => 'NB',
		'ontario.site2.com' => 'ON',
		'quebec.site2.com' => 'QC',
		'saskatchewan.site2.com' => 'SK',
		'stjohns.site2.com' => 'NB',
		'whitehorse.site2.com' => 'YT',
		'winnipeg.site2.com' => 'MB',
		'yellowknife.site2.com' => 'YT',
	},
	'site1' => {
		'abbotsford.site1.ca' => 'BC',
		'barrie.site1.ca' => 'ON',
		'belleville.site1.ca' => 'ON',
		'brantford.site1.ca' => 'ON',
		'calgary.site1.ca' => 'AB',
		'cariboo.site1.ca' => 'BC',
		'chatham.site1.ca' => 'ON',
		'comoxvalley.site1.ca' => 'BC',
		'cornwall.site1.ca' => 'ON',
		'cranbrook.site1.ca' => 'BC',
		'edmonton.site1.ca' => 'AB',
		'ftmcmurray.site1.ca' => 'AB',
		'guelph.site1.ca' => 'ON',
		'halifax.site1.ca' => 'NS',
		'hamilton.site1.ca' => 'ON',
		'hat.site1.ca' => 'AB',
		'kamloops.site1.ca' => 'BC',
		'kelowna.site1.ca' => 'BC',
		'kingston.site1.ca' => 'ON',
		'kitchener.site1.ca' => 'ON',
		'lethbridge.site1.ca' => 'ON',
		'londonon.site1.ca' => 'ON',
		'montreal.site1.ca' => 'QC',
		'nanaimo.site1.ca' => 'BC',
		'newbrunswick.site1.ca' => 'NB',
		'newfoundland.site1.ca' => 'NF',
		'niagara.site1.ca' => 'ON',
		'ottawa.site1.ca' => 'ON|QC',
		'owensound.site1.ca' => 'ON',
		'peace.site1.ca' => 'AB',
		'pei.site1.ca' => 'PE',
		'peterborough.site1.ca' => 'ON',
		'princegeorge.site1.ca' => 'BC',
		'quebec.site1.ca' => 'QC',
		'reddeer.site1.ca' => 'AB',
		'regina.site1.ca' => 'SK',
		'saguenay.site1.ca' => 'QC',
		'sarnia.site1.ca' => 'ON',
		'saskatoon.site1.ca' => 'AB',
		'sherbrooke.site1.ca' => 'QC',
		'skeena.site1.ca' => 'BC',
		'soo.site1.ca' => 'ON',
		'sudbury.site1.ca' => 'ON',
		'sunshine.site1.ca' => 'BC',
		'territories.site1.ca' => 'YT',
		'thunderbay.site1.ca' => 'ON',
		'toronto.site1.ca' => 'ON',
		'troisrivieres.site1.ca' => 'QC',
		'vancouver.site1.ca' => 'BC',
		'victoria.site1.ca' => 'BC',
		'whistler.site1.ca' => 'BC',
		'whitehorse.site1.ca' => 'YT',
		'windsor.site1.ca' => 'ON',
		'winnipeg.site1.ca' => 'MB',
		'yellowknife.site1.ca' => 'YT',
	},
	'site4' => {
		'calgary.site4.com' => 'AB',
		'centre-du-quebec.site4.com' => 'QC',
		'edmonton.site4.com' => 'AB',
		'estrie.site4.com' => 'QC',
		'fredericton.site4.com' => 'NB',
		'gatineau-hull.site4.com' => 'ON|QC',
		'halifax.site4.com' => 'NS',
		'hamilton.site4.com' => 'ON',
		'london.site4.com' => 'ON',
		'moncton.site4.com' => 'NB',
		'montreal.site4.com' => 'QC',
		'montreal-rive-nord.site4.com' => 'QC',
		'montreal-rive-sud.site4.com' => 'QC',
		'ottawa.site4.com' => 'ON|QC',
		'quebec.site4.com' => 'QC',
		'quebec-rive-sud.site4.com' => 'QC',
		'regina.site4.com' => 'SK',
		'saguenay-lac-st-jean.site4.com' => 'QC',
		'saint-john.site4.com' => 'NB',
		'saskatoon.site4.com' => 'SK',
		'terrebonne.site4.com' => 'QC',
		'toronto.site4.com' => 'ON',
		'vancouver.site4.com' => 'BC',
		'victoria.site4.com' => 'BC',
		'windsor.site4.com' => 'ON',
		'winnipeg.site4.com' => 'MB',
	},
	'site3' => {
		'calgary' => 'AB',
		'central-ontario' => 'ON',
		'edmonton' => 'AB',
		'greater-toronto' => 'ON',
		'hamilton-niagara' => 'ON',
		'interior' => 'BC',
		'metro-vancouver' => 'BC',
		'n_alberta' => 'AB',
		'new-brunswick' => 'NB',
		'newfoundland' => 'NF',
		'northern-bc' => 'BC',
		'northern-ontario' => 'ON',
		'nova-scotia' => 'NS',
		'nw_territories' => 'YT',
		'quebec' => 'QC',
		'regina' => 'SK',
		'saskatoon' => 'SK',
		'south-eastern-ontario' => 'ON',
		'south-western-ontario' => 'ON',
		'vancouver-island' => 'BC',
		'winnipeg' => 'MB',
		'yukon' => 'AB',
	},
);

our %cities = (
	'site1' => {
		'abbotsford.site1.ca' => 'abbotsford',
		'barrie.site1.ca' => 'barrie',
		'belleville.site1.ca' => 'belleville',
		'brantford.site1.ca' => 'brantford',
		'calgary.site1.ca' => 'calgary',
		'cariboo.site1.ca' => 'cariboo',
		'chatham.site1.ca' => 'chatham',
		'comoxvalley.site1.ca' => 'comoxvalley',
		'cornwall.site1.ca' => 'cornwall',
		'cranbrook.site1.ca' => 'cranbrook',
		'edmonton.site1.ca' => 'edmonton',
		'ftmcmurray.site1.ca' => 'ftmcmurray',
		'guelph.site1.ca' => 'guelph',
		'halifax.site1.ca' => 'halifax',
		'hamilton.site1.ca' => 'hamilton',
		'hat.site1.ca' => 'hat',
		'kamloops.site1.ca' => 'kamloops',
		'kelowna.site1.ca' => 'kelowna',
		'kingston.site1.ca' => 'kingston',
		'kitchener.site1.ca' => 'kitchener',
		'lethbridge.site1.ca' => 'lethbridge',
		'londonon.site1.ca' => 'londonon',
		'montreal.site1.ca' => 'montreal',
		'nanaimo.site1.ca' => 'nanaimo',
		'newbrunswick.site1.ca' => 'newbrunswick',
		'newfoundland.site1.ca' => 'newfoundland',
		'niagara.site1.ca' => 'niagara',
		'ottawa.site1.ca' => 'ottawa|QC',
		'owensound.site1.ca' => 'owensound',
		'peace.site1.ca' => 'peace',
		'pei.site1.ca' => 'pei',
		'peterborough.site1.ca' => 'peterborough',
		'princegeorge.site1.ca' => 'princegeorge',
		'quebec.site1.ca' => 'quebec',
		'reddeer.site1.ca' => 'reddeer',
		'regina.site1.ca' => 'regina',
		'saguenay.site1.ca' => 'saguenay',
		'sarnia.site1.ca' => 'sarnia',
		'saskatoon.site1.ca' => 'saskatoon',
		'sherbrooke.site1.ca' => 'sherbrooke',
		'skeena.site1.ca' => 'skeena',
		'soo.site1.ca' => 'soo',
		'sudbury.site1.ca' => 'sudbury',
		'sunshine.site1.ca' => 'sunshine',
		'territories.site1.ca' => 'territories',
		'thunderbay.site1.ca' => 'thunderbay',
		'toronto.site1.ca' => 'toronto',
		'troisrivieres.site1.ca' => 'troisrivieres',
		'vancouver.site1.ca' => 'vancouver',
		'victoria.site1.ca' => 'victoria',
		'whistler.site1.ca' => 'whistler',
		'whitehorse.site1.ca' => 'whitehorse',
		'windsor.site1.ca' => 'windsor',
		'winnipeg.site1.ca' => 'winnipeg',
		'yellowknife.site1.ca' => 'yellowknife',
	},
	'site4' => {
		'calgary.site4.com' => 'calgary',
		'centre-du-quebec.site4.com' => 'quebec',
		'edmonton.site4.com' => 'edmonton',
		'estrie.site4.com' => 'estrie',
		'fredericton.site4.com' => 'fredericton',
		'gatineau-hull.site4.com' => 'gatineau',
		'halifax.site4.com' => 'halifax',
		'hamilton.site4.com' => 'hamilton',
		'london.site4.com' => 'london',
		'moncton.site4.com' => 'moncton',
		'montreal.site4.com' => 'montreal',
		'montreal-rive-nord.site4.com' => 'montreal',
		'montreal-rive-sud.site4.com' => 'montreal',
		'ottawa.site4.com' => 'ottawa',
		'quebec.site4.com' => 'quebec',
		'quebec-rive-sud.site4.com' => 'quebec',
		'regina.site4.com' => 'regina',
		'saguenay-lac-st-jean.site4.com' => 'saguenay',
		'saint-john.site4.com' => 'saint-john',
		'saskatoon.site4.com' => 'saskatoon',
		'terrebonne.site4.com' => 'terrebonne',
		'toronto.site4.com' => 'toronto',
		'vancouver.site4.com' => 'vancouver',
		'victoria.site4.com' => 'victoria',
		'windsor.site4.com' => 'windsor',
		'winnipeg.site4.com' => 'winnipeg',
	},
);

sub get_city {
	my ($section, $path) = @_;
	my $city;
	foreach my $loc (keys %{$cities{$section}}) {
		$city = $cities{$section}{$loc};
		return uc($city) if $path =~ m#^$section/$loc#;
	}
	undef
}

our %prov2acs;

sub get_prov {
	my ($ad) = @_;
	my $prov;
	foreach my $loc (keys %{$locales{$ad->{section}}}) {
		$prov = $locales{$ad->{section}}->{$loc};
		return $prov if $ad->{path} =~ m#$loc/#;
	}
	undef
}

1;

